import { Operation } from '@kubb/oas';
import { OperationSchemas } from '@kubb/plugin-oas';
import { ReactNode } from 'react';
import { P as PluginSvelteQuery } from './types-64YHTP7S.cjs';
import { FunctionParams } from '@kubb/react';
import '@kubb/core';

type Props$3 = {
    /**
     * Name of the function
     */
    name: string;
    typeName: string;
    clientName: string;
    typeSchemas: OperationSchemas;
    operation: Operation;
    dataReturnType: PluginSvelteQuery['resolvedOptions']['client']['dataReturnType'];
    pathParamsType: PluginSvelteQuery['resolvedOptions']['pathParamsType'];
};
declare function Mutation({ name, clientName, pathParamsType, dataReturnType, typeSchemas, operation }: Props$3): ReactNode;

type Props$2 = {
    /**
     * Name of the function
     */
    name: string;
    queryOptionsName: string;
    queryKeyName: string;
    queryKeyTypeName: string;
    typeSchemas: OperationSchemas;
    operation: Operation;
    pathParamsType: PluginSvelteQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginSvelteQuery['resolvedOptions']['client']['dataReturnType'];
};
type GetParamsProps$2 = {
    pathParamsType: PluginSvelteQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginSvelteQuery['resolvedOptions']['client']['dataReturnType'];
    typeSchemas: OperationSchemas;
};
declare function Query({ name, queryKeyTypeName, queryOptionsName, queryKeyName, pathParamsType, dataReturnType, typeSchemas, operation }: Props$2): ReactNode;
declare namespace Query {
    var getParams: ({ pathParamsType, dataReturnType, typeSchemas }: GetParamsProps$2) => FunctionParams;
}

type Props$1 = {
    name: string;
    typeName: string;
    typeSchemas: OperationSchemas;
    operation: Operation;
    pathParamsType: PluginSvelteQuery['resolvedOptions']['pathParamsType'];
    keysFn: ((keys: unknown[]) => unknown[]) | undefined;
};
type GetParamsProps$1 = {
    pathParamsType: PluginSvelteQuery['resolvedOptions']['pathParamsType'];
    typeSchemas: OperationSchemas;
};
declare function QueryKey({ name, typeSchemas, pathParamsType, operation, typeName, keysFn }: Props$1): ReactNode;
declare namespace QueryKey {
    var getParams: ({ pathParamsType, typeSchemas }: GetParamsProps$1) => FunctionParams;
}

type Props = {
    name: string;
    clientName: string;
    queryKeyName: string;
    typeSchemas: OperationSchemas;
    pathParamsType: PluginSvelteQuery['resolvedOptions']['pathParamsType'];
};
type GetParamsProps = {
    pathParamsType: PluginSvelteQuery['resolvedOptions']['pathParamsType'];
    typeSchemas: OperationSchemas;
};
declare function QueryOptions({ name, clientName, typeSchemas, pathParamsType, queryKeyName }: Props): ReactNode;
declare namespace QueryOptions {
    var getParams: ({ pathParamsType, typeSchemas }: GetParamsProps) => FunctionParams;
}

export { Mutation, Query, QueryKey, QueryOptions };
